package Div3 (Div3(..), mkDiv3) where

interface Div3 =
    reset     :: Action
    nextDigit :: (Bit 4) -> Action
    isDiv3    :: Bool

mkDiv3 :: Module (Div3)
mkDiv3 =
    module
	modsum :: Reg (Bit 2) <- mkReg 0

	interface
	    reset = (modsum := 0)
	    isDiv3 = (modsum == 0)
	    nextDigit d = action
	                      let mod3 :: (Bit 4) -> (Bit 2)
				  mod3 x = case (x) of
					       0  -> 0
					       1  -> 1
					       2  -> 2
					       3  -> 0
					       4  -> 1
					       5  -> 2
					       6  -> 0
					       7  -> 1
					       8  -> 2
					       9  -> 0
					       10 -> 1
					       11 -> 2
					       12 -> 0
					       13 -> 1
					       14 -> 2
					       15 -> 0
			      modsum := mod3 (zeroExtend (mod3 d) +
						 zeroExtend modsum))

{-
            -- another way to define nextDigit

	    nextDigit d =
		let sum :: Bit 5
		    sum = zeroExtend modsum + zeroExtend d
		in  modsum := case sum of
				  0  -> 0
				  1  -> 1
				  2  -> 2
				  3  -> 0
				  4  -> 1
				  5  -> 2
				  6  -> 0
				  7  -> 1
				  8  -> 2
				  9  -> 0
				  10 -> 1
				  11 -> 2
				  12 -> 0
				  13 -> 1
				  14 -> 2
				  15 -> 0
				  16 -> 1
				  17 -> 2
-}

